#include<stdio.h>
#include<math.h>
#include <gsl/gsl_integration.h>

double integrand(double x, void* params) {
	return exp(-pow(x,2));
}

double erf(double b) {
	gsl_function F;
	F.function = &integrand;
	int limit = 9999;
	gsl_integration_workspace* w;
	w = gsl_integration_workspace_alloc(limit);
	double a=0,acc=1e-6,eps=1e-6,result,error;
	gsl_integration_qags(&F,a,b,acc,eps,limit,w,&result,&error);
	gsl_integration_workspace_free(w);
	return result;
}

int main() {
	double xmin=-3,xmax=3,dx=1.0/1000;
	for(double x=xmin;x<=xmax;x+=dx) {
		printf("%10g%10g\n",x,erf(x));
	}
return 0;
}