#include<stdio.h>
#include<math.h>
#include<gsl/gsl_vector.h>
#include<gsl/gsl_matrix.h>
#include<stdlib.h>
#include<gsl/gsl_linalg.h>
#include<gsl/gsl_blas.h>
#include<assert.h>
#include "functions.h"

int main()
{
    printf("To investigate the effect of CC-transformation on function with singularity at endpoint:\n");
    returns returns = integrate(f,0,1,1.0e-8,1.0e-8,"no_CC");
    printf("1/sqrt(x) from 0 to 1 without CC: %34g    with global error: %2g \n",returns.value,returns.error);
    printf("\n");
    returns = integrate(f,0,1,1.0e-8,1.0e-8,"CC");
    printf("1/sqrt(x) from 0 to 1 with CC: %37g    with global error: %2g \n",returns.value,returns.error);
    printf("\n");printf("\n");

    printf("To investigate the effect of CC-transformation on PI precision:\n");
    returns = integrate(g,0,1,1.0e-8,1.0e-8,"no_CC");
    printf("4*sqrt(1-pow(x,2)) from 0 to 1 without CC: %25.20g    with global error: %2g \n",returns.value,returns.error);
    printf("\n");
    returns = integrate(g,0,1,1.0e-8,1.0e-8,"CC");
    printf("4*sqrt(1-pow(x,2)) from 0 to 1 with CC: %28.20g    with global error: %2g \n",returns.value,returns.error);
    printf("\n");printf("\n");

    printf("To demonstrate converging integrals with infinite boundaries:\n");
    returns = integrate(h,-INFINITY,0,1.0e-8,1.0e-8,"no_CC");
    printf("exp(-pow(x,2)) from -INFINITY to 0 without CC: %21g    with global error: %2g \n",returns.value,returns.error);
    printf("\n");
    returns = integrate(h,0,INFINITY,1.0e-8,1.0e-8,"no_CC");
    printf("exp(-pow(x,2)) from 0 to INFINITY without CC: %22g    with global error: %2g \n",returns.value,returns.error);
    printf("\n");
    returns = integrate(h,-INFINITY,INFINITY,1.0e-8,1.0e-8,"no_CC");
    printf("exp(-pow(x,2)) from -INFINITY to INFINITY without CC: %14g    with global error: %2g \n",returns.value,returns.error);
    return 0;
}
